/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void Paste0CB();
static void Paste1CB();
static Boolean ConvertProc();
static void LoseProc();
static void GetValueProc();

static Atom xa_filename;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, copy, paste0, paste1;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtOpenApplication(&app_context, "Selectparam", NULL, 0,
                     &argc, argv, NULL, sessionShellWidgetClass, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* eLXg͗̈ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [Rs[] {^ --> L: ZNVL */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, text);
    XtManageChild(copy);

    /* (1) [΃pX] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste0 = XmCreatePushButton(panel, "paste0", al, ac);
    XtAddCallback(paste0, XmNactivateCallback, Paste0CB, text);
    XtManageChild(paste0);

    /* (2) [t@C] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste1 = XmCreatePushButton(panel, "paste1", al, ac);
    XtAddCallback(paste1, XmNactivateCallback, Paste1CB, text);
    XtManageChild(paste1);

    /* (3) "_FILENAME" ̃Ag𐶐 */
    xa_filename = XmInternAtom(XtDisplay(toplevel), "_FILENAME", False);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* L: [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* ZNVL (3̃R[obNo^) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, NULL))
        /* LłCeLXg\Ēm点 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* L: ZNV̏LƂɌĂяo */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* ZNV̏L҂łȂȂC\ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* v: [΃pX] {^̃R[obN */
static void Paste0CB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    int which = 0;

    /* (4) ZNVvɃp[^t (0 ͐΃pXŗv) */
    XtSetSelectionParameters(text, XA_PRIMARY, XA_INTEGER, &which, 1, 32);

    /* ZNṼf[^v (f[^̓R[obNŎ󂯎) */
    XtGetSelectionValue(text, XA_PRIMARY, xa_filename, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* v: [t@C] {^̃R[obN */
static void Paste1CB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    int which = 1;

    /* (5) ZNVvɃp[^t (1 ̓t@Ĉ݂v) */
    XtSetSelectionParameters(text, XA_PRIMARY, XA_INTEGER, &which, 1, 32);

    /* ZNṼf[^v (f[^̓R[obNŎ󂯎) */
    XtGetSelectionValue(text, XA_PRIMARY, xa_filename, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* L: ZNṼf[^vꂽƂɌĂяo */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;
    Atom param_type;
    XtPointer param_val;
    unsigned long param_len;
    int param_format;

    /* ]f[^pӂĕԂ */
    if (*selection == XA_PRIMARY && *target == xa_filename) {
        string = XmTextGetString(w);   /* ]͓̂͂ꂽeLXg */
        XtGetSelectionParameters(w, XA_PRIMARY, NULL, &param_type,
                                 &param_val, &param_len, &param_format);
        /* (6) p[^̒l 1 ȂCt@C̕o */
        if (param_type == XA_INTEGER && param_len > 0 && *(int*)param_val == 1) {
            string = strrchr(string, '/');
            string++;
        }
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ō NULL ǉ */
        *type_ret = XA_STRING;         /* ̗͉p̃eLXĝ݈ */
        *format_ret = 8;               /* ̃tH[}bg 8 */
        return True;   /* ]f[^̏ɐƂ} */
    }
    else
        return False;  /* vꂽZNVƃ^CvႤ */
}

/* v: ZNṼf[^󂯎ƂɌĂяo */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* f[^̎󂯎Ɏs */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    /* 󂯎f[^eLXgEEBWFbgɃy[Xg */
    if (*selection == XA_PRIMARY && *type == XA_STRING)
        XmTextSetString(w, (char *)val);
    else
        XBell(XtDisplay(w), 0);  /* ^CvႤƃxŎs̍} */

    XtFree((char *)val);
}
