/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Clipboard", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* eLXg͗̈ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* ̈ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    /* [Rs[] --> Nbv{[hɃf[^Rs[ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, text);
    XtManageChild(copy);

    /* [y[Xg] --> Nbv{[hf[^o */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* [Rs[] {^̃R[obN */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    char *string;
    XTextProperty textprop;
    XmString label;
    long item_id;
    static int private_id = 0;
    long data_id;

    /* eLXgEEBWFbg̒go */
    string = XmTextGetString(text);
    if (string == NULL || *string == NULL) {
        XBell(XtDisplay(text), 0);
        return;
    }

    /* (1) }`oCgRpEhEeLXgɕϊ */
    if (XmbTextListToTextProperty(XtDisplay(w), &string, 1, XStdICCTextStyle,
                             &textprop) != Success || textprop.value == NULL) {
        XBell(XtDisplay(w), 0);  /* ϊɎs (͂ꂽ) */
        return;
    }
    XtFree(string);

    /* KȖOŃRpEhEXgOĂ */
    label = XmStringCreateLocalized("_my_text");

    /* Nbv{[hւ̃Rs[Jn */
    if (XmClipboardStartCopy(XtDisplay(text), XtWindow(text), label,
                             XtLastTimestampProcessed(XtDisplay(text)),
                             NULL, NULL, &item_id) != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(textprop.value);
        return;
    }
    /* (2) Nbv{[hɃf[^Rs[ (tH[}bg "COMPOUND_TEXT") */
    if (XmClipboardCopy(XtDisplay(text), XtWindow(text), item_id,
                        "COMPOUND_TEXT", textprop.value, strlen(textprop.value),
                        private_id, &data_id) != ClipboardSuccess) {
        XmClipboardCancelCopy(XtDisplay(text), XtWindow(text), item_id);
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(textprop.value);
        return;
    }
    /* Nbv{[hւ̃Rs[I (ۂɃf[^]) */
    if (XmClipboardEndCopy(XtDisplay(text), XtWindow(text), item_id)
                                                  != ClipboardSuccess) {
        XBell(XtDisplay(text), 0);
        XmStringFree(label);
        XtFree(textprop.value);
        return;
    }
    private_id++;
    XmStringFree(label);
    XtFree(textprop.value);
}

/* [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    char buff[BUFSIZ];
    unsigned long num_bytes;
    long private_id;
    XTextProperty textprop;
    char **clist;
    int count;

    /* (3) Nbv{[hf[^o(tH[}bg "COMPOUND_TEXT") */
    if (XmClipboardRetrieve(XtDisplay(text), XtWindow(text),
                         "COMPOUND_TEXT", buff, sizeof(buff), &num_bytes,
                         &private_id) != ClipboardSuccess || num_bytes == 0) {
        XBell(XtDisplay(text), 0);
        return;
    }
    buff[num_bytes] = '\0';  /* Ō NULL t */

    /* (4) RpEhEeLXg}`oCgɖ߂ */
    textprop.value = buff;
    textprop.encoding = XmInternAtom(XtDisplay(w), "COMPOUND_TEXT", False);
    textprop.format = 8;
    textprop.nitems = num_bytes;
    if (XmbTextPropertyToTextList(XtDisplay(w),
                                  &textprop, &clist, &count) != Success) {
        XBell(XtDisplay(w), 0);  /* ϊɎsƃxō} */
        return;
    }

    /* Nbv{[h̃f[^eLXgɃy[Xg */
    XmTextSetString(text, clist[0]);
    XFreeStringList(clist);  /* svȂ̂ŉ */
}
